<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<html>
  <!-- 
  IBM Confidential OCO Source Material
  5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70 COPYRIGHT International Business Machines Corp.  2009
  The source code for this program is not published or otherwise divested
  of its trade secrets, irrespective of what has been deposited with the
  U.S. Copyright Office.
  -->
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
          <style type="text/css">
                @import "./dojo/dijit/themes/soria/soria.css";
                @import "./dojo/dojo/resources/dojo.css";
                @import "./dojo/dojox/grid/resources/Grid.css";
                @import "./dojo/dojox/grid/resources/tundraGrid.css";
          </style>
          <script type="text/javascript" src="./dojo/dojo/dojo.js" djConfig="parseOnLoad: true, isDebug: false">
          </script>
          <script type="text/javascript">
            dojo.require("dojo.parser");
            dojo.require("dijit.form.Form");
            dojo.require("dijit.Dialog");
            dojo.require("dijit.layout.BorderContainer");
            dojo.require("dijit.layout.ContentPane");
            dojo.require("dijit.form.ValidationTextBox");
            dojo.require("dijit.TitlePane");
            dojo.require("dijit.form.Button");
            dojo.require("dijit.form.CheckBox");
            dojo.require("blabber.ErrorDialog");
           
          </script>
        <style>
          .formContainer {    
              width:600px;
              height:600px;
          }
          label {
              width:150px;
              float:left;
          }
        </style>
          <title>Generic Status Update Application</title>
    </head>
    <body class="soria" bgcolor="#E1EBFB">
        <div dojoType="dijit.layout.BorderContainer" design="sidebar" style="width: 800px; height: 100%; margin-left: auto; margin-right: auto; border: 1px solid #E1EBFB;">
            <div dojoType="dijit.layout.ContentPane" region="top" style="font-family:courier;font-size:xx-large;font-weight:bold">Generic Status Update Application</div>
            <div dojoType="dijit.layout.ContentPane" region="center">
                <div dojoType="dijit.layout.BorderContainer" design="sidebar" gutters="false">
                    <div dojoType="dijit.layout.ContentPane" region="leading" style="width:450px;padding:20px;text-align:left">
                        </br>
                        <span style="font-size:large;font-weight:bold;">Welcome to the Generic Status Update Application</span>
                        <p style="font-size:medium;">This is a fully functioning status update application written using Dojo and JPA.
                        </p>
                        <p style="font-size:medium;">
                           Try out the application by registering (click the button below)
                           or if you've already registered, you can enter your sign-in details in the fields on the right.
                        </p>
                        <div id="RegisterButton" dojoType="dijit.form.Button">
                          <script type="dojo/method" event="onClick">
                            // If the RegisterButton is clicked, navigate to the Registration page...
                            window.location = "./Registration.jsp";
                          </script>
                          <span style="font-size:large">Click here to sign-up!</span>
                        </div>
                    </div>
                    <div dojoType="dijit.layout.ContentPane" region="trailing" style="padding:20px;width:250px;background-color:#F5F5F5;">
                        <form dojoType="dijit.form.Form" id="SignInForm" action="./signIn" method="POST">   
                            
                            </br>
                            <span style="font-size:large;font-weight:bold">Existing users sign-in here!</span></br></br>
                            <label style="font-size:medium;font-style:italic;width:200px" for="username">What's your username?</label>
                            <input type="text" 
                                   name="username" 
                                   id="username" 
                                   value=""
                                   promptMessage="Enter your username here"
                                   dojoType="dijit.form.ValidationTextBox"
                                   regExp="[a-zA-Z0-9]{6,20}"
                                   required="true"
                                   invalidMessage="Usernames only contain alpha-numerics and are between 6 and 20 characters" />          
                            </br></br>
                            <label style="font-size:medium;font-style:italic;width:200px" for="password">What's your password?</label>
                            <input type="password" 
                                   name="password" 
                                   id="password" 
                                   value=""
                                   promptMessage="Enter your password here"
                                   dojoType="dijit.form.ValidationTextBox"
                                   regExp="[a-zA-Z0-9]{4,8}"
                                   required="true"
                                   invalidMessage="Password are only between 4 and 8 alpha-numeric characters" />            
                            </br></br>
                            <button type="submit" id="SignInButton" dojoType="dijit.form.Button">
                                <script type="dojo/method" event="onClick" args="event">
                                    // Prevent the submit action going any further...
                                    event.preventDefault();
                                    event.stopPropagation();

                                    var form = dijit.byId("SignInForm");
                                    if (form.validate()) {
                                        // Validate the form contents, if passed then attempt sign-on...
                                        dojo.xhrPost({
                                          form: dojo.byId("SignInForm"),
                                          handleAs: "json",
                                          load: function(data) {
                                            if (data.success) {
                                              // Sign-on succeeded, navigate to profile page for user...
                                              console.log("User id: " + dijit.byId("username").attr("value"));
                                              window.location = "./displayProfile?username=" + dijit.byId("username").attr("value");
                                            }
                                            else {
                                              // Sign-on failed, display an error message...
                                              var d = new blabber.ErrorDialog({title:"Sign-in failed!", errorMessage:"Your username and/or password was not recognized, please try again."});
			                                  d.show();        				              
                                            }
                                          }
                                        });
                                    }
                                    else {
                                      var d = new blabber.ErrorDialog({title:"Invalid sign-in details", errorMessage:"Please ensure that your sign-in details are present and correct!"});
			                          d.show();        				              
                                    }
                                </script>
                                <span style="font-size:large">Sign in!</span>
                             </button>
                        </form>
                    </div>
                </div>
            </div>
            <div dojoType="dijit.layout.ContentPane" region="bottom"><i>This is a sample application</i></div>
        </div>       
    </body>
</html>
