<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<html>
  <!-- 
  IBM Confidential OCO Source Material
  5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70 COPYRIGHT International Business Machines Corp.  2009
  The source code for this program is not published or otherwise divested
  of its trade secrets, irrespective of what has been deposited with the
  U.S. Copyright Office.
  -->
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
    <style type="text/css">
    @import "./dojo/dijit/themes/soria/soria.css";
    @import "./dojo/dojo/resources/dojo.css";
    @import "./dojo/dojox/grid/resources/Grid.css";
    @import "./dojo/dojox/grid/resources/soriaGrid.css";
    </style>
    <script type="text/javascript" src="./dojo/dojo/dojo.js" djConfig="parseOnLoad: true, isDebug: false">
    </script>
    <script type="text/javascript">
    dojo.require("dojo.parser");
    dojo.require("dijit.form.Form");
    dojo.require("blabber.PostGrid");
    dojo.require("blabber.UserGrid");
    dojo.require("blabber.ErrorDialog");
    dojo.require("dijit.Dialog");
    dojo.require("dijit.layout.BorderContainer");
    dojo.require("dijit.layout.ContentPane");
    dojo.require("dijit.layout.TabContainer");
    dojo.require("dijit.form.SimpleTextarea");
    dojo.require("dijit.form.ValidationTextBox");
    dojo.require("dijit.form.Button");
    dojo.require("dijit.form.CheckBox");    
    </script>
    <style>
    .dojoxGridHeader { display:none; }
    dojoxGridScrollbox { height: 100%; }
    .formContainer {    
        width:600px;
        height:600px;
    }
    label {
        width:150px;
        float:left;
    }
    </style>
    <title>Generic Status Update Application</title>
</head>
<body class="soria" bgcolor="#E1EBFB">
  <div dojoType="dijit.layout.BorderContainer" design="sidebar" style="width: 800px; height: 100%; margin-left: auto; margin-right: auto; border: 1px solid #E1EBFB;">
    <div dojoType="dijit.layout.ContentPane" region="top" >
        <span style="font-family:courier;font-size:xx-large;font-weight:bold">
            Generic Status Update Application
        </span>
        <c:if test="${signedOnUserName ne null}">
            <!-- If the signedOnUserName session attribute matches the requested username parameter then display the logout button... -->
            <br>
            <div dojoType="dijit.form.Button">
                <script type="dojo/connect" event="onClick">
                    window.location = "./displayProfile?username=${signedOnUserName}";
                </script>
                Home
            </div>
            <div dojoType="dijit.form.Button">
                <script type="dojo/connect" event="onClick">
                    dojo.xhrGet({
                      url: "./signOut",
                      load: function(data) {
                        window.location = "./Home.jsp";  
                      }
                    });
                </script>
                Sign-out
            </div>
        </c:if>
        <c:if test="${signedOnUserName eq null}">
          <div dojoType="dijit.form.Button">
            <script type="dojo/connect" event="onClick">
              window.location = "./Home.jsp";
            </script>
            Home
          </div>
          <div dojoType="dijit.form.Button">
            <script type="dojo/connect" event="onClick">
              window.location = "./Registration.jsp";
            </script>
            Register
          </div>
        </c:if>
    </div>
    <div dojoType="dijit.layout.ContentPane" region="center">
        <!-- This tab container is the center panel of the profile page...-->
        <div dojoType="dijit.layout.TabContainer" tabPosition="right-h">
          <c:if test="${signedOnUserName eq param.username}">
          <!-- This border container holds the update section (top) and the status updates (center) -->
            <div dojoType="dijit.layout.ContentPane" title="Home" >
              <div dojoType="dijit.layout.BorderContainer" design="headline" gutters="false" selected="true">
                <!-- Update section... -->                
                <!-- This border container holds the text entry box (leading pane), character left indicator (center) and update button (bottom) -->
                <div dojoType="dijit.layout.BorderContainer" region="top" style="height:123px" design="sidebar" gutters="false">
                  <div dojoType="dijit.layout.ContentPane" region="leading">
                    <span style="font-family:courier;font-size:x-large;font-weight:bold">What's my status?</span></br>
                    <div id="StatusUpdateText" dojoType="dijit.form.SimpleTextarea" rows="5" cols="58" style="width:500px"><script type="dojo/method" event="onKeyUp">dojo.byId("remainingChars").innerHTML=140-this.attr('value').length;</script></div>
                  </div>
                  <div dojoType="dijit.layout.ContentPane" region="center" style="text-align:center;vertical-align:middle;">
                      Remaining characters:</br>
                      <span id="remainingChars" style="font-family:courier;font-size:xx-large;font-weight:bold">140</span>
                  </div>
                  <div dojoType="dijit.layout.ContentPane" region="bottom" align="center">
                      <button id="UpdateButton" dojoType="dijit.form.Button">
                      <script type="dojo/connect" event="onClick">
                        var post = dijit.byId("StatusUpdateText").attr("value");
                        var lengthOfPost = post.length;
                        if (lengthOfPost==0){
                          var d = new blabber.ErrorDialog({title:"No status!", errorMessage:"Don't you think you should add some status text?"});
                          d.show();
                        }
                        else if (lengthOfPost>140) {                    
                          var d = new blabber.ErrorDialog({title:"Too much information!", errorMessage:"Please keep your status to 140 characters!"});
                          d.show();
                        }
                        else
                        {
                            dojo.xhrPost({
                              url: "./handlePost",
                              content: { "status" : post },
                              load: function(response, ioArgs) {
                                      dijit.byId("HomeTabGrid").refreshStatus();
                                      dijit.byId("StatusUpdateText").attr("value","");
                                      dojo.byId("remainingChars").innerHTML = 140;
                                    }
                            });
                        }                                                                                                                    
                      </script>
                      <span style="font-size:large">Update!</span></button>
                  </div>
                </div>
                <!-- Status section... -->
                <div dojoType="dijit.layout.ContentPane" region="center" style="z-index:100">
                  <div id="HomeTabGrid" dojoType="blabber.PostGrid" style="height:100%;" profile="true" username="${param.username}" style="z-index:100">
                  </div>
                </div>                
              </div>
            </div>         
            </c:if>
            <div dojoType="dijit.layout.ContentPane" title="Profile" style="z-index:100">
              <c:if test="${signedOnUserName eq param.username}">
              <script type="dojo/connect" event="onShow">
                // There is a timing issue on showing grids in ContentPane tabs, when the tab is selected render the 
                // grid after a small pause...
                function refreshGrid() {
                  dijit.byId("ProfileTab").refreshStatus();
                  dijit.byId('ProfileTab_Grid').render();                  
                }
                setTimeout(refreshGrid,200);                               
              </script>
              </c:if>
                <div dojoType="dijit.layout.BorderContainer" design="headline" gutters="false" style="z-index:100">
                  <div dojoType="dijit.layout.ContentPane" region="top" style="height:120px;" style="z-index:100">
                    <img src="UserIcon${image}.JPG" align="middle" hspace=10>
                    <span style="font-family:courier;font-size:xx-large;font-weight:bold">${param.username}</span></br></br>
                    <c:if test="${signedOnUserName ne null and signedOnUserName ne param.username}">
                      <button dojoType="dijit.form.ToggleButton" checked="${requestedUserIsTracked}" iconClass="dijitCheckBoxIcon">
                      <script type="dojo/connect" event="onClick">
                        // If the "Track me" button is clicked, then place a call to update the tracking value...
                        dojo.xhrGet({
                          url: "./updateTrackingData?username=${param.username}&tracked=" + this.attr("checked")                          
                        });
                      </script>
                      Track me</button>
                    </c:if>
                  </div>
                  <div dojoType="dijit.layout.ContentPane" region="center" style="z-index:100">
                    <div id="ProfileTab" dojoType="blabber.PostGrid" style="height:100%;" profile="false" username="${param.username}" style="z-index:100">
                    </div>
                  </div>
                </div>
            </div>
        <div dojoType="dijit.layout.ContentPane" title="Tracking Data">
          <script type="dojo/connect" event="onShow">
                // There is a timing issue on showing grids in ContentPane tabs, when the tab is selected render the 
                // grid after a small pause...
                function refreshGrid() {
                  dijit.byId("TrackingTab").refreshStatus();
                  dijit.byId('TrackingTab_Grid').render();                  
                }
                setTimeout(refreshGrid,200);                               
           </script>
          <div dojoType="dijit.layout.BorderContainer" design="headline" gutters="false">
            <div dojoType="dijit.layout.ContentPane" region="top" style="height:120px;">
              <img src="UserIcon${image}.JPG" align="middle" hspace=10>
              <span style="font-family:courier;font-size:xx-large;font-weight:bold">${param.username}</span></br></br>
              <span style="font-size:medium;">is tracking...</span>
            </div>
            <div dojoType="dijit.layout.ContentPane" region="center">
              <div id="TrackingTab" dojoType="blabber.UserGrid" style="height:100%;" gridStoreURL="./getTrackedUsers?username=${param.username}">
              </div>
            </div>
          </div>
        </div>
        <div dojoType="dijit.layout.ContentPane" title="Search">
          <script type="dojo/connect" event="onShow">
                // There is a timing issue on showing grids in ContentPane tabs, when the tab is selected render the 
                // grid after a small pause...
                function refreshGrid() {
                  dijit.byId("SearchTab").refreshStatus();
                  dijit.byId('SearchTab_Grid').render();                  
                }
                setTimeout(refreshGrid,200);                               
           </script>
          <div dojoType="dijit.layout.BorderContainer" design="headline" gutters="false">
            <div dojoType="dijit.layout.ContentPane" region="top" style="height:120px;">
              <span style="font-family:courier;font-size:x-large;font-weight:bold">Search</span></br></br>
              <span style="font-size:medium;">Enter a search filter and click "Search!"</span></br></br>
              <input type="text" 
                     name="username" 
                     id="username" 
                     value=""
                     promptMessage="Enter your search filter here"
                     dojoType="dijit.form.ValidationTextBox"
                     regExp="[a-z0-9\*]{1,20}"
                     required="true"
                     invalidMessage="Usernames only contain alpha-numerics (but you can use the * wildcard)" />          
              <div dojoType="dijit.form.Button">
                <script type="dojo/connect" event="onClick">
                  var filter = dijit.byId("username").attr("value");
                  if (filter.length == 0) {
                    var d = new blabber.ErrorDialog({title:"No search filter!", errorMessage:"You need to enter a filter to search on"});
                    d.show();
                  }
                  else {
                    var grid = dijit.byId("SearchTab");
                    grid.attr("gridStoreURL", "./search?filter=" + filter);
                    grid.refreshStatus();
                  }
                </script>
                Search!
              </div>
            </div>
            <div dojoType="dijit.layout.ContentPane" region="center">
              <div id="SearchTab" dojoType="blabber.UserGrid" style="height:100%;" gridStoreURL="./search?filter=">
              </div>
            </div>
          </div>
        </div>
      </div>        
    </div>
    <div dojoType="dijit.layout.ContentPane" region="bottom">
      <i>This is a sample application</i>
    </div>
  </div>
</body>
</html>
