<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<html>
  <!-- 
  IBM Confidential OCO Source Material
  5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70 COPYRIGHT International Business Machines Corp.  2009
  The source code for this program is not published or otherwise divested
  of its trade secrets, irrespective of what has been deposited with the
  U.S. Copyright Office.
  -->
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
          <style type="text/css">
                @import "./dojo/dijit/themes/soria/soria.css";
                @import "./dojo/dojo/resources/dojo.css";
                @import "./dojo/dojox/grid/resources/Grid.css";
                @import "./dojo/dojox/grid/resources/tundraGrid.css";
          </style>
          <script type="text/javascript" src="./dojo/dojo/dojo.js" djConfig="parseOnLoad: true, isDebug: false">
          </script>
          <script type="text/javascript">
            dojo.require("dojo.parser");
            dojo.require("dijit.form.Form");
            dojo.require("blabber.ErrorDialog");
            dojo.require("dijit.layout.BorderContainer");
            dojo.require("dijit.layout.ContentPane");
            dojo.require("dijit.form.ValidationTextBox");
            dojo.require("blabber.ValidationTextBox");
            dojo.require("dijit.TitlePane");
            dojo.require("dijit.form.Button");
            dojo.require("dijit.form.CheckBox");
           
          </script>
        <style>
          .formContainer {    
              width:600px;
              height:600px;
          }
          label {
              width:150px;
              float:left;
          }
        </style>
          <title>Generic Status Update Application</title>
    </head>
    <body class="soria" bgcolor="#E1EBFB">
        <div dojoType="dijit.layout.BorderContainer" design="sidebar" style="width: 800px; height: 100%; margin-left: auto; margin-right: auto; border: 1px solid #E1EBFB;">
            <div dojoType="dijit.layout.ContentPane" region="top" style="font-family:courier;font-size:xx-large;font-weight:bold">Generic Status Update Application</div>
            <div dojoType="dijit.layout.ContentPane" region="center" >
                <form dojoType="dijit.form.Form" id="RegistrationForm" action="./registration" method="POST">                                        
                    <p><b>Registration</b></p>
                    <p><i>Please enter your details to register to use the Generic Status Update Application...</i></p>
                    <div id="UserDetails" dojoType="dijit.TitlePane" title="Enter your details...">
                        <label for="username">Username</label>
                        <input type="text" 
                               name="username" 
                               id="username" 
                               value=""
                               promptMessage="What username would you like?"
                               dojoType="blabber.ValidationTextBox"
                               regExp="[a-zA-Z0-9]{6,20}"
                               required="true"
                               serverValidationAddress="./registration?validateUserName=TRUE&userName="
                               standardErrorMsg="Your username can only contain alpha-numerics and must be between 6 and 20 characters"
                               serverValidationErrorMsg="The username suggested has already been registered" />         
                        </br></br>
                        <label for="email">E-mail address</label>
                        <input type="text" 
                               name="email" 
                               id="email" 
                               value=""
                               promptMessage="What's your e-mail address?"
                               dojoType="blabber.ValidationTextBox"
                               regExp="([\w-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([\w-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)"
                               required="true"
                               serverValidationAddress="./registration?validateEmailAddress=TRUE&emailAddress="
                               standardErrorMsg="You need to enter a valid e-mail address"
                               serverValidationErrorMsg="The e-mail address supplied has already been registered to another user." />            
                        </br></br>
                        <label for="password">Password</label>
                        <input type="password" 
                               name="password" 
                               id="password" 
                               value=""
                               promptMessage="Please enter a password"
                               dojoType="dijit.form.ValidationTextBox"
                               regExp="[a-zA-Z0-9]{4,8}"
                               required="true"
                               invalidMessage="Your password must be between 4 and 8 alpha-numeric characters" />            
                        </br></br>
                        <label for="passwordConfirmation">Confirm password</label>
                        <input type="password" 
                               name="passwordConfirmation" 
                               id="passwordConfirmation" 
                               value=""
                               promptMessage="Could you confirm you password please?"
                               dojoType="dijit.form.ValidationTextBox"
                               regExp="[a-zA-Z0-9]{4,8}"
                               validator="return this.attr('value') == dijit.byId('password').attr('value')"
                               required="true"
                               invalidMessage="Your confirmation does not match the original password!" />      
                        </br></br>
                    </div>
                    <div id="UserIcon" dojoType="dijit.TitlePane" title="Select your icon..." open="false">
                        <input type="radio" dojoType="dijit.form.RadioButton" name="UserIcon" id="iconRadio1" value="1" checked/><img src="UserIcon1.JPG" align="middle" hspace=10>
                        <input type="radio" dojoType="dijit.form.RadioButton" name="UserIcon" id="iconRadio2" value="2"/><img src="UserIcon2.JPG" align="middle" hspace=10 />
                        <input type="radio" dojoType="dijit.form.RadioButton" name="UserIcon" id="iconRadio3" value="3"/><img src="UserIcon3.JPG" align="middle" hspace=10/>
                        <input type="radio" dojoType="dijit.form.RadioButton" name="UserIcon" id="iconRadio4" value="4"/><img src="UserIcon4.JPG" align="middle" hspace=10/>
                        </br>
                        <input type="radio" dojoType="dijit.form.RadioButton" name="UserIcon" id="iconRadio5" value="5"/><img src="UserIcon5.JPG" align="middle" hspace=10/>
                        <input type="radio" dojoType="dijit.form.RadioButton" name="UserIcon" id="iconRadio6" value="6"/><img src="UserIcon6.JPG" align="middle" hspace=10/>
                        <input type="radio" dojoType="dijit.form.RadioButton" name="UserIcon" id="iconRadio7" value="7"/><img src="UserIcon7.JPG" align="middle" hspace=10/>
                        <input type="radio" dojoType="dijit.form.RadioButton" name="UserIcon" id="iconRadio8" value="8"/><img src="UserIcon8.JPG" align="middle" hspace=10/>
                    </div>
                    </br></br>
                    <button type="submit" id="RegisterButton" dojoType="dijit.form.Button">
                      <script type="dojo/method" event="onClick" args="event">
                        event.preventDefault();
                        event.stopPropagation();

                        var form = dijit.byId("RegistrationForm");
                        if (form.validate()) {
                          // If all the form data is valid then allow the submit to go ahead...
                          dojo.xhrPost({
                              form: dojo.byId("RegistrationForm"),
                              handleAs: "json",
                              load: function(response) {
                                      if (response.success == true) {
                                        // If registration succeeded go to the profile page...
                                        console.log("Registration Success");                                        
                                        window.location = "./displayProfile?username=" + dijit.byId("username").attr("value");
                                      }
                                      else {
                                        // If registration failed, then display an error message...
                                          console.log("Registration failed");
                                          var d = new blabber.ErrorDialog({title:"Registration Failed!", errorMessage:response.msg});
                                          d.show();
                                      }
                                    }
                            });
                        }
                        else {                          
                          var d = new blabber.ErrorDialog({title:"Invalid registration data", errorMessage:"Some of the registration data you've entered is not valid. Please correct the highlighted fields."});
			              d.show();
                        }
                      </script>
                      Create my account!
                    </button>

                    <div id="CacnelButton" dojoType="dijit.form.Button">
                      <script type="dojo/method" event="onClick">window.location = "./Home.jsp";</script>Cancel</div>
                </form>
            </div>
            <div dojoType="dijit.layout.ContentPane" region="bottom"><i>This is a sample application</i></div>
        </div>       
    </body>
</html>
