//  Licensed Materials - Property of IBM
//  
//  5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70
//  
//  Copyright IBM Corp. 2009
//
dojo.provide("blabber.ValidationTextBox");
dojo.require("dijit.form.ValidationTextBox");
dojo.declare("blabber.ValidationTextBox",[dijit.form.ValidationTextBox],{
  serverValidationAddress: "",
  standardErrorMsg: "",
  serverValidationErrorMsg: "",
  validator: function(value,constraints){
    var isValid = this.inherited(arguments);
    if (isValid) {
        var serverValidationSuccess = true;    
        dojo.xhrGet({url: this.serverValidationAddress + value,
                     sync: true,
                     handleAs: "json",
                     load: function (response) {                                
                             serverValidationSuccess = response.isValid;
                           }
                    });
        if (serverValidationSuccess != true) {
          this.invalidMessage = this.serverValidationErrorMsg;
        }
    }
    else {
      this.invalidMessage = this.standardErrorMsg;
    }
    isValid = isValid && serverValidationSuccess;    
    return isValid;
   }
});

