/*
 * @start_prolog@
 * ============================================================================
 *  Licensed Materials - Property of IBM
 *  
 *  5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70
 *  
 *  Copyright IBM Corp. 2009
 * ============================================================================
 * @end_prolog@
 * 
 * Change activity:
 * 
 * Issue       Date        Name           Description
 * ----------- ----------- -------------- ------------------------------------
 */
package com.ibm.ws.eba.example.blabber;

import java.io.IOException;

import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.ibm.ws.eba.example.blabber.persistence.spi.BlabberUserInterface;

public class BlabberUtils {

  public static final BlabberUserInterface getBlabberService()
  throws IOException
{
  try {
    InitialContext ic = new InitialContext();
    return (BlabberUserInterface) ic.lookup("aries:services/" + BlabberUserInterface.class.getName());
  } catch (NamingException e) {
    e.printStackTrace();
    IOException ioe = new IOException("** Failed to bind BlabberUserInterface");
    ioe.initCause(e);
    throw ioe;
  }
}
}
