/*
 * @start_prolog@
 * ============================================================================
 *  Licensed Materials - Property of IBM
 *  
 *  5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70
 *  
 *  Copyright IBM Corp. 2009
 * ============================================================================
 * @end_prolog@
 * 
 * Change activity:
 * 
 * Issue       Date        Name           Description
 * ----------- ----------- -------------- ------------------------------------
 */
package com.ibm.ws.eba.example.blabber;

/**
 * Constants class for static final values used
 * in the blabber application.
 *
 */
public class Constants
{
	
	public static final String _CONTENT_TYPE = "text/json";
    public static final String _SIGNED_ON_USER_NAME = "signedOnUserName";
    public static final String _REQUESTED_USER_IS_BEING_TRACKED = "requestedUserIsTracked";

    /**
     * This is the request parameter that will contain the latest status post from the user.
     */
    public static final String _POST_PARM = "status";
	
    /**
     * This constant is used as the key under which to store the BletherUserInterface in
     * the servlet context.
     */
    public static final String _USER_INTERFACE_CONTEXT_ATTRIBUTE = "userInterface";
	public final static String _USER_NAME_PARM = "username";
	public final static String _PASSWORD_PARM = "password";
	public final static String _EMAIL_ADDRESS_PARM = "email";
	public final static String _AVATAR_PARM = "UserIcon";
	public final static String _IS_TRACKED_PARM = "tracked";
	public final static String _SEARCH_FILTER = "filter";

	public final static String _FOR_USER_PROFILE_PARM = "forUserProfile";
	
	public final static String _SUCCESS = "success";
	public final static String _MESSAGE = "msg";
	public final static String _IMAGE = "image";
	public final static String _TIMESTAMP = "timestamp";
	public final static String _UPDATE = "update";
	public final static String _ITEMS = "items";
	public final static String _CHECKED = "true";
	public final static String _UNCHECKED = "false";
	public final static String _IDENTIFIER = "identifier";
	public final static String _LABEL = "label";
		
	public final static String _GET = "GET";
	public final static String _POST = "POST";
	static final String _VALIDATE_USER_NAME_PARM = "validateUserName";
	static final String _VALIDATE_EMAIL_PARM = "validateEmailAddress";
	static final String _SUGGESTED_USER_NAME = "userName";
	static final String _SUGGESTED_EMAIL = "emailAddress";
	static final String _IS_VALID_ATTR = "isValid";
}
