/*
 * @start_prolog@
 * ============================================================================
 *  Licensed Materials - Property of IBM
 *  
 *  5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70
 *  
 *  Copyright IBM Corp. 2009
 * ============================================================================
 * @end_prolog@
 * 
 * Change activity:
 * 
 * Issue       Date        Name           Description
 * ----------- ----------- -------------- ------------------------------------
 */
package com.ibm.ws.eba.example.blabber;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class HandlePost extends HttpServlet
{
	private static final long serialVersionUID = 111928899411597970L;

	@Override
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{			
			// POST action requested...
			String signedInUser = (String) request.getSession().getAttribute(Constants._SIGNED_ON_USER_NAME);
			String status = request.getParameter(Constants._POST_PARM);
			if (signedInUser != null)
			{
			  // If user is signed in create the new posting
			  BlabberUtils.getBlabberService().postContent(signedInUser, status);
			}

	}
}
