--  Licensed Materials - Property of IBM
--
--  5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70
--
--  Copyright IBM Corp. 2009
--
connect 'jdbc:derby:BLABBERDB/;create=true';
CREATE TABLE "APP"."POST" ("ID" BIGINT NOT NULL, "CONTENT" VARCHAR(255), "TIMESTAMP" TIMESTAMP, "AUTHOR_USERNAME" VARCHAR(255));
CREATE TABLE "APP"."USERINFO" ("USERNAME" VARCHAR(255) NOT NULL, "AVATAR" INTEGER, "EMAILADDRESS" VARCHAR(255) NOT NULL, "PASSWORD" VARCHAR(255) NOT NULL);
CREATE TABLE "APP"."USERINFO_USERINFO" ("USERINFO_USERNAME" VARCHAR(255), "TRACKING_USERNAME" VARCHAR(255));
ALTER TABLE "APP"."USERINFO" ADD CONSTRAINT "12" PRIMARY KEY ("USERNAME");
ALTER TABLE "APP"."POST" ADD CONSTRAINT "34" PRIMARY KEY ("ID");
ALTER TABLE "APP"."USERINFO_USERINFO" ADD CONSTRAINT "56" FOREIGN KEY ("USERINFO_USERNAME") REFERENCES "APP"."USERINFO" ("USERNAME");
ALTER TABLE "APP"."USERINFO_USERINFO" ADD CONSTRAINT "78" FOREIGN KEY ("TRACKING_USERNAME") REFERENCES "APP"."USERINFO" ("USERNAME");
CREATE TABLE "APP"."OPENJPA_SEQUENCE_TABLE" ("ID" SMALLINT NOT NULL, "SEQUENCE_VALUE" BIGINT);
ALTER TABLE "APP"."OPENJPA_SEQUENCE_TABLE" ADD CONSTRAINT "AB" PRIMARY KEY ("ID");
exit;